;  ******************************************

;   www.endtas.com/robot hobby robotics site

;  ******************************************

;              plywood biped
;               source code

;  ******************************************

;            iki ayakli yryc

;  ******************************************
;         Copyright zkal zsoy 2003
;  ******************************************

; Porta 1  : ayaklari ileri geri hareket ettiren servo cikisi
; Porta 2  : ayak uclarini yukari asagi hareket ettiren servo cikisi


; Porta 1  : output for the servo which moves legs back and forth.
; Porta 2  : output for the servo which moves legtips up and down.

	list	p=16f84

	#include "P16F84.INC" ; Include header file
; bellekler

sayac1	EQU     h'000c'
sayac2	EQU     h'000d'
timer	equ	h'000e'
timsay	equ	h'000f'
statemp	equ	h'0010'
wtemp	equ	h'0011'
poyuk	equ	h'0012'
poile	equ	h'0013'
poort	equ	h'0014'


; degiskenler

sagond	equ	d'10'
sagark	equ	d'4'

saghav	equ	d'6'
solhav	equ	d'8'

solond	equ	d'4'
solark  equ	d'10'


	org	0

start	clrf	INTCON
	goto	main
	nop
	nop

intvec	movwf   wtemp           ; save off current W register contents
	movf	STATUS,w        ; move status register into W register
	movwf	statemp       	; save off contents of STATUS register


       	btfss  	INTCON,T0IF    	; Timer0 interrupt?
       	goto   	pop
	bcf    	INTCON,T0IF    	; Clear the Timer0 interrupt flag
	banksel	PORTB	
	incf	timsay
	btfsc	STATUS,Z
	incf	timer


	movfw	timsay
	subwf	poyuk,0
	btfss	STATUS,C
	goto	cik1
cik2	bsf	PORTA,0
	goto	sagaya
cik1	bcf	PORTA,0

sagaya

	movfw	timsay
	subwf	poile,0
	btfss	STATUS,C
	goto	cik12
cik22	bsf	PORTA,1
	goto	ortaya
cik12	bcf	PORTA,1

ortaya
	movfw	timsay
	subwf	poort,0
	btfss	STATUS,C
	goto	cik13
cik23	bsf	PORTA,2
	goto	pop
cik13	bcf	PORTA,2



pop	
	movf    statemp,w     	; retrieve copy of STATUS register
	movwf	STATUS          ; restore pre-isr  STATUS register contents
	swapf   wtemp,f
	swapf   wtemp,w         ; restore pre-isr  W register contents

	retfie


main
	banksel TRISB
	movlw	b'11111111'	; PORTB giri,
	movwf	TRISB

	movlw	b'00000000'	; PORTA k
	movwf   TRISA

	call	init

	banksel	PORTB

	clrf	PORTB
	bcf	OPTION_REG,7	; Enable portb pullups
basadon
	movlw 	d'6'
	movwf	poyuk
	movlw 	d'6'
	movwf	poile

aprog	

	call	ileri

	btfss	PORTB,4
	call	sagcarp

	btfss	PORTB,3
	call	solcarp

	goto	aprog
;****************************
sagcarp	call	geri
	call	geri
	call	sola
	call	sola
	return
;****************************
solcarp	call	geri
	call	geri
	call	saga
	call	saga
	return
;****************************
saga	movlw 	d'9'		;8
	movwf	poyuk
	call	uzbekle

	movlw 	d'6'		;7
	movwf	poile
	call	uzbekle
	
	movlw 	d'6'		;6
	movwf	poyuk
	call	uzbekle

	movlw 	d'8'		;5
	movwf	poile
	call	uzbekle

	movlw 	d'4'		;4
	movwf	poyuk
	call	uzbekle

	movlw 	d'6'		;3
	movwf	poile
	call	uzbekle

	movlw 	d'6'		;2
	movwf	poyuk
	call	uzbekle

	movlw 	d'8'		;1
	movwf	poile
	call	uzbekle

	return
;****************************
sola	movlw 	d'8'		;1
	movwf	poile
	call	uzbekle

	movlw 	d'6'		;2
	movwf	poyuk
	call	uzbekle

	movlw 	d'6'		;3
	movwf	poile
	call	uzbekle

	movlw 	d'4'		;4
	movwf	poyuk
	call	uzbekle

	movlw 	d'8'		;5
	movwf	poile
	call	uzbekle

	movlw 	d'6'		;6
	movwf	poyuk
	call	uzbekle

	movlw 	d'6'		;7
	movwf	poile
	call	uzbekle
	
	movlw 	d'9'		;8
	movwf	poyuk
	call	uzbekle

	return
;****************************
ileri	movlw 	d'8'
	movwf	poile
	call	uzbekle

	movlw 	d'9'
	movwf	poyuk
	call	uzbekle

	movlw 	d'6'
	movwf	poile
	call	uzbekle

	movlw 	d'4'
	movwf	poyuk
	call	uzbekle
	return
;****************************
geri	movlw 	d'6'
	movwf	poile
	call	uzbekle

	movlw 	d'9'
	movwf	poyuk
	call	uzbekle

	movlw 	d'8'
	movwf	poile
	call	uzbekle

	movlw 	d'4'
	movwf	poyuk
	call	uzbekle
	return
;****************************

uzbekle	
	call	bekle
	call	bekle
	call	bekle
	call	bekle
	call	bekle
	return
;****************************
init	movlw  	0x8a	;0x8F           ; Set the timer prescaler.
	banksel OPTION_REG
       	movwf  	OPTION_REG
	banksel	TMR0
	movlw  	0x00
       	movwf  	TMR0
       	bsf    	INTCON,T0IE    ; Enable the timer interrupt.
       	bsf    	INTCON,GIE     ; Enable global interrupts.
	return
;****************************
bekle	bsf	PORTA,4
	clrf 	sayac1

loop1   clrf 	sayac2

loop	incf 	sayac2
        nop
        nop
	nop
        btfss 	sayac2,7
        goto  	loop
	nop
	nop
	nop
	incf  	sayac1
	btfss 	sayac1,7		
	goto 	loop1
	bcf	PORTA,4
        return

azbekle	movlw	d'30'
	movwf	sayac2
	movlw	d'255'
	movwf	sayac1

azbek1	decfsz	sayac1
	goto	azbek1

	decfsz	sayac2
	goto	azbek1
	return


	end
